﻿class DrawSine {
    
    private var my_width:Number;
    private var my_height:Number;
    private var steps:Number;
    
    private var step_x:Number;
    
    private var draw_array = new Array();
    
    private var target_mc:MovieClip;
	
	private var stroke_color:Number = 0x000000;
	private var stroke_weight:Number = 1;
	private var draw_fill:Boolean = false;
	private var fill_color:Number = 0xFF0000;
	private var fill_height:Number;
	private var fill_alpha:Number;
    
    public function DrawSine( _mc:MovieClip, 
							 w:Number, 
							 h:Number, 
							 s:Number ) {
        target_mc = _mc;
        my_width = w;
        my_height = h;
        steps = s;
        step_x = w / steps;
        
        for ( var i = 0; i < steps; i ++ ) {
            draw_array.push( { x:step_x * i, y:0 } );
        }
        
    }
	
	public function set_stroke( sw:Number, sc:Number ):Void {
		stroke_weight = sw;
		stroke_color = sc;
	}
	
	public function set_fill( f:Boolean, fc:Number, fa:Number ):Void {
		draw_fill = f;
		fill_color = fc;
		fill_alpha = fa;
	}
    
    public function draw_waves( wave_array:Array ):Void {
        var draw_count = draw_array.length;
        var wave_count = wave_array.length;
        for ( var i = 0; i < wave_count; i++ ) {
            var inc    = wave_array[i].cycles * Math.PI * 2 / steps;
            for ( var j = 0; j < draw_count; j ++ ) {
				if ( i == 0 ) {
					draw_array[j].y = Math.sin( wave_array[i].phase + ( inc * j ) ) * wave_array[i].radius;
				} else {
               		draw_array[j].y += Math.sin( wave_array[i].phase + ( inc * j ) ) * wave_array[i].radius;
				}
            }
        }
        
        target_mc.clear();
		if ( stroke_weight > 0 ) {
			target_mc.lineStyle( stroke_weight, stroke_color );
		}
		
		if ( draw_fill ) {
			target_mc.beginFill( fill_color, fill_alpha );
		}
        
        target_mc.moveTo( draw_array[0].x, draw_array[0].y );
        for( var i = 1; i < draw_count; i++ ) {
			var x = draw_array[i].x;
			var y = draw_array[i].y
            target_mc.lineTo( x, y );
        }
		
		if ( draw_fill ) {
			target_mc.lineTo( x, my_height / 2 );
			target_mc.lineTo( 0, my_height/ 2 );
			target_mc.lineTo( 0, draw_array[0].y );
			target_mc.endFill();
		}
    }
    
    
} 


